unit Vraag1U_Memo;

// A solution for Question 1

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ComCtrls, ExtCtrls;

type
  TfrmVraagEen = class(TForm)
    bmbSluitAf: TBitBtn;
    lblFormOpskrif: TLabel;
    grbVraag11: TGroupBox;
    grbVraag12: TGroupBox;
    grbVraag13: TGroupBox;
    grbVraag14: TGroupBox;
    lblGewig: TLabel;
    lblLengte: TLabel;
    btnVraag1_1: TButton;
    redVraag11: TRichEdit;
    edtGewig: TEdit;
    edtLengte: TEdit;
    lblDoelGewig: TLabel;
    edtDoelGewig: TEdit;
    btnVraag1_2: TButton;
    redVraag12: TRichEdit;
    lblNaam: TLabel;
    edtNaam: TEdit;
    rgpGeslag: TRadioGroup;
    grbAllergie: TGroupBox;
    chkAllergie: TCheckBox;
    lblKode: TLabel;
    btnVraag1_3: TButton;
    edtLidmaatskapkode: TEdit;
    btnVraag1_4: TButton;
    redVraag14: TRichEdit;
    grbVraag15: TGroupBox;
    btnVraag1_5: TButton;
    redVraag15: TRichEdit;
    procedure FormCreate(Sender: TObject);
    procedure btnVraag1_1Click(Sender: TObject);
    procedure btnVraag1_2Click(Sender: TObject);
    procedure btnVraag1_3Click(Sender: TObject);
    procedure btnVraag1_4Click(Sender: TObject);
    procedure btnVraag1_5Click(Sender: TObject);
    procedure bmbSluitAfClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmVraagEen: TfrmVraagEen;

implementation

{$R *.dfm}
{$R+}

var
  arrLidKodes: array [1 .. 20] of String;


  // ==================================================================
  // Vraag 1.1
  // ==================================================================
procedure TfrmVraagEen.bmbSluitAfClick(Sender: TObject);
begin
 Application.Terminate;
end;

procedure TfrmVraagEen.btnVraag1_1Click(Sender: TObject);
var
  rGewig, rLengte, rBMI: real;
begin
  rGewig := StrToFloat(edtGewig.Text);
  rLengte := StrToFloat(edtLengte.Text);
  rBMI := rGewig / sqr(rLengte);
  redVraag11.Clear;
  redVraag11.Lines.Add('BMI = ' + FloatToStrF(rBMI, ffFixed, 8,5));
  if (rBMI < 18.5) then
    redVraag11.Lines.Add('Ondergewig')
  else if (rBMI < 25) then
    redVraag11.Lines.Add('Normale gewig')
  else
    redVraag11.Lines.Add('Oorgewig');
end;

// ==================================================================
// Vraag 1.2
// ==================================================================
procedure TfrmVraagEen.btnVraag1_2Click(Sender: TObject);
var
  rGewig, rDoelGewig: real;
  iGetalDae: integer;
begin
  redVraag12.Clear;
  rGewig := StrToFloat(edtGewig.Text);
  rDoelGewig := StrToFloat(edtDoelGewig.Text);
  iGetalDae := 0;
  if (rGewig > rDoelGewig) then
  begin
    redVraag12.Lines.Add('Dag' + #9 + 'Gewig');
    while (rGewig > rDoelGewig) do
    begin
      inc(iGetalDae, 1);
      rGewig := rGewig - 0.375;
      redVraag12.Lines.Add(IntToStr(iGetalDae) + #9 + FloatToStrF(rGewig, ffFixed,8, 3));
    end; // while
  end // if
  else
    redVraag12.Lines.Add('Ongeldige waarde ingesleutel');
end;

// ==================================================================
// Vraag 1.3
// ==================================================================
procedure TfrmVraagEen.btnVraag1_3Click(Sender: TObject);
var
  sLidmaatskapKode, sNaam: String;
  A, iRandom, iGetalLetters, iTotaal: integer;
  sKontroleGetal : String;
begin
  sNaam := Uppercase(edtNaam.Text);

  sLidmaatskapKode := '';
  for A := 1 to Length(sNaam) do
    if NOT(sNaam[A] IN ['A', 'E', 'I', 'O', 'U', #32]) then
      sLidmaatskapKode := sLidmaatskapKode + sNaam[A];

  iGetalLetters := length(sLidmaatskapKode);

  case rgpGeslag.ItemIndex of
    0: sLidmaatskapKode := sLidmaatskapKode + '-V-';
    1: sLidmaatskapKode := sLidmaatskapKode + '-M-';
  end;

  iRandom := Random(9) + 1;
  iTotaal := iRandom + 10 + iGetalLetters;

   sKontroleGetal := IntToStr(iRandom) +  IntToStr(iTotaal);

  sLidmaatskapKode := sLidmaatskapKode + sKontroleGetal;

  if chkAllergie.Checked then
    sLidmaatskapKode := sLidmaatskapKode + '*';

  edtLidmaatskapKode.Text := sLidmaatskapKode;

  // Alternative for replacing the vowels:
  // sLidmaatskapKode := StringReplace(sLidmaatskapKode, 'A', '',[rfReplaceAll, rfIgnoreCase]);
  // sLidmaatskapKode := StringReplace(sLidmaatskapKode, 'E', '',[rfReplaceAll, rfIgnoreCase]);
  // sLidmaatskapKode := StringReplace(sLidmaatskapKode, 'I', '',[rfReplaceAll, rfIgnoreCase]);
  // sLidmaatskapKode := StringReplace(sLidmaatskapKode, 'O', '',[rfReplaceAll, rfIgnoreCase]);
  // sLidmaatskapKode := StringReplace(sLidmaatskapKode, 'U', '',[rfReplaceAll, rfIgnoreCase]);
  // sLidmaatskapKode := StringReplace(sLidmaatskapKode, #32, '',[rfReplaceAll, rfIgnoreCase]);
end;

// ==================================================================
// Vraag 1.4
// ==================================================================
procedure TfrmVraagEen.btnVraag1_4Click(Sender: TObject);
var
  iRandgetal1, iRandGetal2 : integer;
  sGeslag     : String;
begin
  iRandgetal1 := Random(20) + 1;
  if pos('-M-', arrLidKodes[iRandgetal1]) = 0 then
    sGeslag := '-M-'
  else
    sGeslag := '-F-';

  repeat
    iRandGetal2 := Random(20) + 1;
  until (pos(sGeslag, arrLidKodes[iRandGetal2]) > 0);

  redVraag14.Clear;
  redVraag14.Lines.Add('Premium lede' + #13);
  redVraag14.Lines.Add(arrLidKodes[iRandgetal1]);
  redVraag14.Lines.Add(arrLidKodes[iRandGetal2]);
end;

// ==================================================================
// Vraag 1.5
// ==================================================================
procedure TfrmVraagEen.btnVraag1_5Click(Sender: TObject);
var
  i, j: integer;
  temp: String;
begin
  //
  for i := 1 to 19 do
    for j := i + 1 to 20 do
    begin
      if arrLidKodes[i] > arrLidKodes[j] then
      begin
        temp := arrLidKodes[i];
        arrLidKodes[i] := arrLidKodes[j];
        arrLidKodes[j] := temp;
      end;
    end;

    for i := 1 to 20 do
      if pos('*', arrLidKodes[i]) > 0
      then redVraag15.Lines.Add(arrLidKodes[i]);

    for i := 1 to 20 do
      if pos('*', arrLidKodes[i]) = 0
      then redVraag15.Lines.Add(arrLidKodes[i]);

end;

  // ==================================================================
  procedure TfrmVraagEen.FormCreate(Sender: TObject);
  begin
    arrLidKodes[1] := 'PRTHNMM-M-421';
    arrLidKodes[2] := 'LYYHNBB-V-623*';
    arrLidKodes[3] := 'DFGQWJJK-M-220*';
    arrLidKodes[4] := 'NBVGTYY-V-926';
    arrLidKodes[5] := 'NBGTRFSSD-V-322*';
    arrLidKodes[6] := 'NJKYTRRTG-M-928';
    arrLidKodes[7] := 'JBHGTYGFTR-V-121';
    arrLidKodes[8] := 'HGTYRJJ-V-522*';
    arrLidKodes[9] := 'KJHYTGFDDRWQ-M-830';
    arrLidKodes[10] := 'NHYTRFDDD-M-221*';
    arrLidKodes[11] := 'NBVGTYYGHG-M-424';
    arrLidKodes[12] := 'CVBGFRXXS-M-726';
    arrLidKodes[13] := 'PLIUYHGTRF-M-323';
    arrLidKodes[14] := 'QWDFGENBG-M-423*';
    arrLidKodes[15] := 'RBRTHNDRKS-V-525';
    arrLidKodes[16] := 'MKJHTGFDD-M-625';
    arrLidKodes[17] := 'SDWRQWDDG-V-726';
    arrLidKodes[18] := 'HNGBBVFFDCCS-V-931';
    arrLidKodes[19] := 'NMBGHFDRLP-V-121';
    arrLidKodes[20] := 'BVCZZXGFDJK-M-122';
  end;

end.
